class NicoTagsController < ApplicationController
  def index
    limit = (params[:limit] || 20).to_i
    cursor = params[:cursor].presence

    q = Tag.nico_tags.includes(:linked_tags)
    q = q.where('tags.updated_at < ?', Time.iso8601(cursor)) if cursor

    tags = q.limit(limit + 1)

    next_cursor = nil
    if tags.size > limit
      next_cursor = tags.last.updated_at.iso8601(6)
      tags = tags.first(limit)
    end

    render json: { tags: tags.map { |tag|
      tag.as_json(include: :linked_tags)
    }, next_cursor: }
  end

  def upload
  end
end
